export class imgType {
  url = "";
  size = 0;
}
export class ItemObject {
  name = "";
  subName = "";
  desc = "";
  _id = "";
  thumbnail = "";
  type: "img" | "video" | "3D" = "img";
  images?: string[];
  videoUrl?: string;
  source = "";
}
export class ColDataType {
  offset = 0;
  items: ShowItem[] = [];
  halfOffset = 0;
  dragging = false;
  speed = 0;
}
export class ShowItem {
  id = "";
  name = "";
  url = "";
  x = 0;
  y = 0;
  z = 0;
  w = 0;
  h = 0;
  opacity = 0;

  currX = 0;
  currY = 0;

  offsetX = 0;
  offsetY = 0;
  offsetZ = 0;
  padding = 0;

  show = false;
  timer: any;
  img: any;
}
export class DialogItem {
  id = "";
  width = 0;
  height = 0;
  x = 0;
  y = 0;
  show = false;
  dataId = "";
  itemIndex = 0;
}
